<template>
  <div class="header">
    <v-app-bar
      height="80px"
      color="primary"
      fixed
      elevate-on-scroll
    >
      <v-toolbar-title>
        <v-row>
          <a
            :href="$t('buttons.mobicoop.route')"
          >
            <v-img
              class="logo ml-10 mr-6"
              :src="this.$t('urlLogoMobicoop')"
              alt="mobicoop"
              height="200"
              width="200"
              contain
              eager
            />
          </a>    
          <a
            :href="$t('buttons.welcome.route')"
          > 
            <v-img
              class="logo"
              :src="this.$t('urlLogoPompey')"
              alt="moove"
              height="200"
              width="200"
              contain
              eager
            />
          </a>
        </v-row>
      </v-toolbar-title>
      <v-spacer />

      <div
        class="hidden-md-and-down"
      >
        <v-btn
          rounded
          text
          :href="$t('buttons.knowMore.route')"
          class=" info--text text-h6 text-none font-weight-bold mr-12"
        >
          {{ $t('buttons.knowMore.label') }}
        </v-btn>
        <v-btn
          rounded
          text
          :href="$t('buttons.guaranteedReturn.route')"
          class=" info--text text-h6 text-none font-weight-bold mr-12"
        >
          {{ $t('buttons.guaranteedReturn.label') }}
        </v-btn>
      </div>

      <div
        v-if="user"
        class="hidden-md-and-down"
      >
        <MMessageBtn
          :unread-message-number="unreadMessageNumber"
          :text-color-class="' info--text text-h6 text-none font-weight-bold mr-12'"
        />
        <MHeaderCommunities
          :user-id="user.id"
          :text-color-class="' info--text text-h6 text-none font-weight-bold '"
          :links-color-class="'black--text'"
        />
        <MHeaderProfile
          :avatar="user.avatars[0]"
          :short-family-name="(user.shortFamilyName) ? user.givenName+' '+user.shortFamilyName : '-'"
          :text-color-class="' info--text text-h6 text-none font-weight-bold mr-12'"
          :links-color-class="'black--text'"
        />
      </div>
      <v-toolbar-items
        v-else
        class="hidden-md-and-down"
      >
        <v-btn
          rounded
          text
          :href="$t('buttons.signup.route')"
          class=" info--text text-h6 text-none font-weight-bold mr-12"
        >
          {{ $t('buttons.signup.label') }}
        </v-btn>
        <v-btn
          rounded
          text
          :href="$t('buttons.logIn.route')"
          class=" info--text text-h6 text-none font-weight-bold"
        >
          {{ $t('buttons.logIn.label') }}
        </v-btn>
      </v-toolbar-items>
      <MHeaderLanguage
        text-class=" info--text text-h6 text-none font-weight-bold"
        :languages="languages"
        :language="dlocale"
        @languageSelected="updateLanguage"
      />
      <!--Display menu when user is connected-->
      <v-menu
        v-if="user"
        bottom
        left
        z-index="9"
      >
        <template v-slot:activator="{ on }">
          <v-btn
            icon
            class="hidden-lg-and-up"
            color="white"
            v-on="on"
          >
            <v-icon>mdi-menu</v-icon>
          </v-btn>
        </template>

        <v-list>
          <v-list-item>
            <v-list-item-title>
              <MHeaderLanguage
                text-class="white--text font-weight-bold"
                :languages="languages"
                :language="dlocale"
                @languageSelected="updateLanguage"
              />
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <MHeaderProfile
                :avatar="user.avatars[0]"
                :short-family-name="(user.shortFamilyName) ? user.givenName+' '+user.shortFamilyName : '-'"
              />
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <MHeaderCommunities
                :user-id="user.id"                  
              />
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                text
                rounded
                :href="$t('buttons.messages.route')"
              >
                {{ $t('buttons.messages.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>

      <!--Display menu when there is no connected user-->
      <v-menu
        v-else
        bottom
        left
        z-index="9"
      >
        <template v-slot:activator="{ on }">
          <v-btn
            class="hidden-lg-and-up"
            v-on="on"
          >
            <v-icon color="primary">
              mdi-menu
            </v-icon>
          </v-btn>
        </template>

        <v-list>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                text
                rounded
                :href="$t('buttons.messages.route')"
              >
                {{ $t('buttons.messages.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                rounded
                text
                :href="$t('buttons.signup.route')"
              >
                {{ $t('buttons.signup.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                rounded
                text
                :href="$t('buttons.logIn.route')"
              >
                {{ $t('buttons.logIn.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>
    </v-app-bar>
    <GamificationNotifications :user-gamification-notifications="(user && user.gamificationNotifications) ? user.gamificationNotifications : null" />
    <GratuityNotifications :user-gratuity-notifications="(user && user.gratuityNotifications) ? user.gratuityNotifications : null" />
    <!-- legal guardian dialog -->
    <v-dialog
      v-if="user"
      v-model="activeLegalGuardianDialog"
      persistent
      max-width="900"
    >
      <v-card>
        <v-card-title
          class="text-h5 justify-center"
        >
          {{ $t('dialog.parentalConsent.title') }}
        </v-card-title>
        <v-card-text v-html="$t('dialog.parentalConsent.content',{'legalGuardianEmail':user.legalGuardianEmail})" />
        <v-card-actions>
          <v-spacer />
          <v-btn
            color="secondary"
            primary
            rounded
            :href="this.$t('buttons.logOut.route')"
          >
            {{ $t('dialog.parentalConsent.buttonLabel') }}
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import { merge, has } from "lodash";
import { messages_en, messages_fr} from "@translations/components/base/MHeader/";
import { messages_client_en, messages_client_fr} from "@clientTranslations/components/base/MHeader/";
import MHeaderProfile from "@components/base/MHeaderProfile.vue";
import MHeaderLanguage from "@components/base/MHeaderLanguage.vue";
import MMessageBtn from "@components/base/MMessageBtn.vue";
import GamificationNotifications from "@components/utilities/gamification/GamificationNotifications";
import GratuityNotifications from "@components/utilities/gratuity/GratuityNotifications";

let MessagesMergedEn = merge(messages_en, messages_client_en);
let MessagesMergedFr = merge(messages_fr, messages_client_fr);

export default {
  i18n: {
    messages: {
      'en': MessagesMergedEn,
      'fr': MessagesMergedFr,
    },
  },
  components: {
    MHeaderProfile,
    MHeaderLanguage,
    MMessageBtn,
    GamificationNotifications,
    GratuityNotifications
  },
  props: {
    user: {
      type: Object,
      default: null
    },
    locale: {
      type: String,
      default: "fr"
    },
    languages: {
      type: Object,
      default: () => {}
    },
    token: {
      type: String,
      default: ''
    },
    gamificationActive:{
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      width: 0,
      snackbar: null,
      defaultLocale: 'fr',
      dlocale: this.locale,
      activeLegalGuardianDialog: false
    }
  },
  computed:{
    unreadMessageNumber(){
      return this.user.unreadCarpoolMessageNumber + this.user.unreadDirectMessageNumber + this.user.unreadSolidaryMessageNumber; 
    }
  },
  mounted() {
    if (has(this.languages, this.locale)) {
      this.dlocale = this.locale;
    } else {
      this.dlocale = this.defaultLocale;
    }
    this.$store.commit('g/setActive',this.gamificationActive);
    this.$store.commit('grt/setActive',this.gratuityActive);
  },
  created() {
    this.$store.commit('a/setToken',this.user?.token ? this.user.token : this.token);
    if(this.user){
      localStorage.setItem('X-LOCALE',this.dlocale);
    }
    if(this.user?.needParentalConsent) {
      this.activeLegalGuardianDialog = true;
    }
    this.$root.$i18n.locale = this.dlocale
  },
  methods:{
    updateLanguage(language) {
      this.$root.$i18n.locale = language
    }
  }
};
</script>
<style scoped lang="scss">
.header {
  margin-bottom: 70px;
}

</style>
